{{/* 
    Render ontoUML using HTML SVG

    Context: ontoUML Data

*/}}

{{ $packageList := partial "onto-uml/data/model-packages" . }}
{{ $elementList := partial "onto-uml/data/model-elements" $packageList }}

<div class="markdown">
    <h1>Project: {{ .name }}</h1>
    <h2>Model: {{ .model.name }}</h2>
    <h3>Diagrammen</h3>

    {{ range .diagrams }}
        <h4>{{ .name }}</h4>
        <blockquote class="book-hint info">
            {{ .description }}
        </blockquote>        
        
        {{ $shapeSvgPathList := slice }}
        {{ $shapeSvgRectangleList := slice }}

        {{ range .contents }}
            
            {{ with .shape }}
                {{ if eq .type "Path" }}
                    {{ $shapeSvgPathList = $shapeSvgPathList | append (dict
                        "shapeId" .id
                        "svgPath" (partial "onto-uml/svg/svg-path" .points)
                    ) }}
                {{ else if eq .type "Rectangle" }}
                    {{ $shapeSvgRectangleList = $shapeSvgRectangleList | append (dict
                        "shapeId" .id
                        "x" .x
                        "y" .y
                        "width" .width
                        "height" .height
                    ) }}    
                {{ end }}
            {{ end }}

        {{ end }}
        
        <svg height="1000" width="1000">
        {{ range $shapeSvgPathList }}
            <path id="{{ .shapeId }}" d="{{ .svgPath }}" stroke="red" stroke-width="1" fill="none" />
        {{ end }}
        {{ range $shapeSvgRectangleList }}
            <rect id="{{ .shapeId }}" x="{{ .x }}" y="{{ .y }}" width="{{ .width }}" height="{{ .height }}" stroke="green" stroke-width="2" fill="none" />
        {{ end }}
        </svg>

    {{ end }}

</div>
